#include <bits/stdc++.h>
using namespace std;
ifstream in("pitmutare.in");
ofstream out("pitmutare.out");
const int Nmax = 303;
const int MOD = int(1e9)+7;

int a[Nmax],b[Nmax];
int va[Nmax],vb[Nmax];
int N,q;

int xnorm[2*Nmax+2];
int from[2*Nmax+2];
int d[2][Nmax][Nmax][Nmax];
int bst[2*Nmax];
int ans[Nmax],ansr[Nmax];

void extd(int &x,long long val){x=(1LL*x + val)%MOD;}

void normal(vector<int> &f,vector<int> &u){
	vector<int> nom;
	for(auto it : f) nom.push_back(2*it);
	for(auto it : u) nom.push_back(2*it+1);
	sort(nom.begin(),nom.end());
	for(int i=0;i<nom.size();i++) xnorm[nom[i]]=i+1;
	for(int i=0;i<f.size();i++) f[i]=xnorm[2*f[i]];
	for(int i=0;i<u.size();i++) u[i]=xnorm[2*u[i]+1];
}

void solv(vector<int> f,vector<int> u){
	sort(f.begin(),f.end());
	sort(u.begin(),u.end());
	int n=f.size();
	normal(f,u);
	for(auto it : f) from[it]=1;
	for(auto it : u) from[it]=2;

	memset(d,0,sizeof(d));
	d[0][0][0][0]=1;
	for(int i=0;i<2*n;i++){
		memset(d[(i+1)%2],0,sizeof(d[(i+1)%2]));
		for(int j=0;j<=n;j++){
			for(int k=0;k<=n;k++){
				for(int s=0;s<=n;s++){
					int val = d[(i)%2][j][k][s];
					if(from[i+1]==1){
						if(0<k) extd(d[(i+1)%2][j][k-1][s+1],1LL*val*k);
						extd(d[(i+1)%2][j+1][k][s],1LL*val);
					}
					else if(from[i+1]==2){
						if(0<j) extd(d[(i+1)%2][j-1][k][s],1LL*val*j);
						extd(d[(i+1)%2][j][k+1][s],1LL*val);
					}
					else exit(1);
				}
			}
		}
	}
	for(int j=0;j<=n;j++) ans[j]=d[0][0][0][j]%MOD;
}

int main(){
	in>>N>>q;
	for(int i=1;i<=N;i++) in>>a[i],va[a[i]]=1;
	for(int i=1;i<=N;i++) in>>b[i],vb[b[i]]=1;
	vector<int> ca,cb;

	//part 1
	for(int i=1;i<=N;i++){
		if(a[i]) ca.push_back(a[i]);
		if(!vb[i]) cb.push_back(i);
	}
	int n1 = ca.size();
	solv(ca,cb);

	//clear
	for(int i=0;i<=N;i++) ansr[i]=ans[i];
	for(int i=0;i<=N;i++) ans[i]=0;
	ca.clear(),cb.clear();

	//part 2
	for(int i=1;i<=N;i++){
		if(!va[i]) ca.push_back(i);
		if(b[i]) cb.push_back(b[i]);
	}
	solv(ca,cb);

	// polinom combine
	for(int i=0;i<=N;i++){
		for(int j=0;j<=N;j++){
			if(ansr[i] && ans[j])
				extd(bst[i+j],1LL*ansr[i]*ans[j]);
		}
	}

	out<<bst[q]<<'\n';
	return 0;
}
