#include <bits/stdc++.h>

using namespace std;

#define mp make_pair
#define pb push_back
#define ll long long

const int nmax = 15;
const int lmax = 3 * 1e4 + 5;
const int inf = (1 << 30);

int n, L, Q;
struct Edge {
	int x, y, c, r;
	Edge() {}
	Edge(int x, int y, int c, int r): x(x), y(y), c(c), r(r) {

	}
};
Edge s[lmax];
int dp[2][nmax];

void update(int &x, int y) {
	x = min(x, y);
}

int bagaDin(int x, int y, int a, int b) {
	for (int i = 0; i < 2; ++i) {
		for (int j = 1; j <= n; ++j) {
			dp[i][j] = inf;
		}
	}
	int prevLine = 0 ;
	dp[prevLine][x] = 0;
	// dp[prevLine][y] = 0;
	for (int i = a; i <= b; ++i) {
		// for (int i = b; i >= a; --i) {
		int currLine = prevLine ^ 1;
		for (int j = 1; j <= n; ++j) {
			dp[currLine][j] = inf;
		}
		for (int j = 1; j <= n; ++j) {
			if (dp[prevLine][j] != inf) {
				dp[currLine][j] = dp[prevLine][j] + s[i].r;// raman in acelasi nod;
			}
		}
		int currX = s[i].x;
		int currY = s[i].y;
		if (dp[prevLine][currY] != inf) {
			update(dp[currLine][currX], dp[prevLine][currY] + s[i].c);
		}
		if (dp[prevLine][currX] != inf) {
			update(dp[currLine][currY], dp[prevLine][currX] + s[i].c);
		}
		prevLine = currLine;
	}

	return dp[prevLine][y];
	// return dp[prevLine][x];
}

#define DIM 10000
char buff[DIM];
int poz = 0;

void citeste(int &numar)
{
	numar = 0;
	//cat timp caracterul din buffer nu e cifra ignor
	while (buff[poz] < '0' || buff[poz] > '9')
		//daca am "golit" bufferul atunci il umplu
		if (++poz == DIM)
			fread(buff, 1, DIM, stdin), poz = 0;
	//cat timp dau de o cifra recalculez numarul
	while ('0' <= buff[poz] && buff[poz] <= '9')
	{
		numar = numar * 10 + buff[poz] - '0';
		if (++poz == DIM)
			fread(buff, 1, DIM, stdin), poz = 0;
	}
}

int main() {
	ios::sync_with_stdio(false);
#ifndef ONLINE_JUDGE
	freopen("razbunare.in", "r", stdin);
	freopen("razbunare.out", "w", stdout);
#endif

	// cin >> n >> L >> Q;
	citeste(n);
	citeste(L);
	citeste(Q);
	for (int i = 1; i <= L; ++i) {
		int x, y, c, r;
		// cin >> x >> y >> c >> r;
		citeste(x);
		citeste(y);
		citeste(c);
		citeste(r);
		s[i] = Edge(x, y, c, r);
	}

	for (int i = 1; i <= Q; ++i) {
		int x, y, a, b;
		// cin >> x >> y >> a >> b;
		citeste(x);
		citeste(y);
		citeste(a);
		citeste(b);

		int ans = bagaDin(x, y, a, b);
		ans = (ans == inf ? -1 : ans);
		cout << ans << "\n";
	}

	return 0;
}